﻿--------------------------------------------------------------------
/*
 SQL Server در Polybase
Site:        http://www.NikAmooz.com
Email:       Info@NikAmooz.com
Instagram:   https://instagram.com/nikamooz/
Telegram:	 https://telegram.me/nikamooz
Created By:  Masoud Taheri , Mehdi Ghapanvari 
*/
--------------------------------------------------------------------
/*
 External Data Source ایجاد
 جهت اتصال به فایل اکسل
*/
USE AdventureWorks
GO

IF NOT EXISTS
(
SELECT 1
FROM sys.external_data_sources ds
WHERE
ds.name = N'DataSourceToExcel'
)
BEGIN
CREATE EXTERNAL DATA SOURCE DataSourceToExcel WITH
(
LOCATION = 'odbc://noplace',
CONNECTION_OPTIONS = 'Driver={CData Excel Source};
DSN=PolybaseToExcel'
);
END
GO
---------------------------------------------------------------------
/*
 EXTERNAL TABLE ایجاد
 جهت اتصال به فایل اکسل
*/
CREATE EXTERNAL TABLE dbo.ExternalSalesOrderHeader
(
[SalesOrderID] [Nvarchar](4000),
[RevisionNumber] [Nvarchar](4000),
[OrderDate] [Nvarchar](4000),
[DueDate] [Nvarchar](4000),
[ShipDate] [Nvarchar](4000),
[Status] [Nvarchar](4000),
[OnlineOrderFlag] [Nvarchar](4000),
[SalesOrderNumber] [Nvarchar](4000),
[PurchaseOrderNumber] [Nvarchar](4000),
[AccountNumber] [Nvarchar](4000),
[CustomerID] [Nvarchar](4000),
[SalesPersonID] [Nvarchar](4000),
[TerritoryID] [Nvarchar](4000),
[BillToAddressID] [Nvarchar](4000),
[ShipToAddressID] [Nvarchar](4000),
[ShipMethodID] [Nvarchar](4000),
[CreditCardID] [Nvarchar](4000),
[CreditCardApprovalCode] [Nvarchar](4000),
[CurrencyRateID] [Nvarchar](4000),
[SubTotal] [Nvarchar](4000),
[TaxAmt] [Nvarchar](4000),
[Freight] [Nvarchar](4000),
[TotalDue] [Nvarchar](4000),
[Comment] [Nvarchar](4000),
[rowguid] [Nvarchar](4000),
[ModifiedDate] [Nvarchar](4000)
)
WITH
(
LOCATION = 'Sheet1',
DATA_SOURCE = DataSourceToExcel
);
GO
-----------------------------------------------------------------------------------------------------
-- Ploybase اجرای کوئری بر روی فایل اکسل با استفاده از 

Select SUM(s.OrderQty * UnitPrice) As Total from dbo.ExternalSalesOrderHeader e
Inner Join Sales.SalesOrderDetail s
On e.SalesOrderID = s.SalesOrderID
Where e.DueDate Between '2011-06-12T00:00:00-07:00' And '2011-06-12T00:00:00-07:00'
-----------------------------------------------------------------------------------------------------
-- ایجاد و پر نمودن جداول در اوراکل
CREATE TABLE regions  ( region_id NUMBER CONSTRAINT region_id_nn NOT NULL  , region_name VARCHAR2(25) );
CREATE UNIQUE INDEX reg_id_pk ON regions (region_id);
ALTER TABLE regions ADD ( CONSTRAINT reg_id_pk PRIMARY KEY (region_id) ) ;
CREATE TABLE countries ( country_id CHAR(2) CONSTRAINT country_id_nn NOT NULL  , country_name VARCHAR2(40) , region_id NUMBER , CONSTRAINT country_c_id_pk PRIMARY KEY (country_id) ) 
 ORGANIZATION INDEX; 
ALTER TABLE countries ADD ( CONSTRAINT countr_reg_fk FOREIGN KEY (region_id) REFERENCES regions(region_id) ) ;
INSERT INTO regions VALUES ( 1, 'Europe' );
INSERT INTO regions VALUES ( 2, 'Americas' );
INSERT INTO regions VALUES ( 3, 'Asia' );
INSERT INTO regions VALUES ( 4, 'Middle East and Africa' );

INSERT INTO countries VALUES ( 'IT', 'Italy' , 1 );
INSERT INTO countries VALUES ( 'JP', 'Japan' , 3 );
INSERT INTO countries VALUES ( 'US' , 'United States of America' , 2  );
INSERT INTO countries VALUES ( 'CA', 'Canada', 2 );
INSERT INTO countries VALUES ( 'CN', 'China', 3 );
INSERT INTO countries VALUES ( 'IN', 'India', 3 );
INSERT INTO countries VALUES ( 'AU', 'Australia', 3 );
INSERT INTO countries VALUES ( 'ZW', 'Zimbabwe', 4 );
INSERT INTO countries VALUES ( 'SG', 'Singapore' , 3  );
INSERT INTO countries VALUES ( 'UK', 'United Kingdom', 1 );
INSERT INTO countries VALUES ( 'FR', 'France', 1 );
INSERT INTO countries VALUES ( 'DE' , 'Germany' , 1  );
INSERT INTO countries VALUES ( 'ZM', 'Zambia', 4 );
INSERT INTO countries VALUES ( 'EG' , 'Egypt' , 4  );
INSERT INTO countries VALUES ( 'BR', 'Brazil', 2 );
INSERT INTO countries VALUES ( 'CH', 'Switzerland', 1 );
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- ایجاد قسمت های مورد نیاز جهت اتصال به اوراکل
Use AdventureWorks
GO

Create Master Key Encryption By Password = 'Kcv256!2%895'
GO

Create Database Scoped Credential OracleCredential
With Identity = 'System', Secret = 'Usawe3&!yrpe'
GO

Create External Data Source OracleDataSource
With 
(
 Location = 'Oracle://localhost:1521',
 Pushdown = ON,
 Credential = OracleCredential
)
GO

CREATE EXTERNAL TABLE ExternalRegions
(
  [REGION_ID] FLOAT(53) NOT NULL, [REGION_NAME] VARCHAR(25) COLLATE Latin1_General_BIN
)
WITH
(
LOCATION = '[orcl].[HR].[REGIONS]',
DATA_SOURCE = OracleDataSource
);

CREATE EXTERNAL TABLE ExternalCountries
(
  [COUNTRY_ID] CHAR(2) COLLATE Latin1_General_BIN NOT NULL, 
  [COUNTRY_NAME] VARCHAR(40) COLLATE Latin1_General_BIN, 
  [REGION_ID] FLOAT(53)
)
WITH
(
LOCATION = '[orcl].[HR].[COUNTRIES]',
DATA_SOURCE = OracleDataSource
);
-----------------------------------------------------------------------------------------------------------------------------------
-- Statistics ایجاد
Create Statistics StatsRegions On ExternalRegions
(Region_Name, Region_ID) With FullScan

Create Statistics StatsCountries On ExternalCountries
(Country_Name, Region_ID, Country_ID) With FullScan
------------------------------------------------------------------------------------------------------------------------------------
/* Temp Table ایجاد
و اجرای کوئری جهت واکشی اطلاعات از جداول اوراکل
*/
Insert Into #Tbl Values ('US'),('JP'),('IT'),('UK'),('CN'),('BR'), ('EG'), ('CH')

Select er.Region_Name, ec.Country_Name, t.COID From ExternalRegions er
Inner Join ExternalCountries ec
 On er.Region_ID = ec.Region_ID
Inner Join #Tbl t
 On t.COID Collate Latin1_General_BIN = ec.Country_ID
GO
---------------------------------------------------------------------------------------------------------
 