﻿--------------------------------------------------------------------
/*
 SQL Server در Polybase
Site:        http://www.NikAmooz.com
Email:       Info@NikAmooz.com
Instagram:   https://instagram.com/nikamooz/
Telegram:	 https://telegram.me/nikamooz
Created By:  Masoud Taheri , Mehdi Ghapanvari 
*/
--------------------------------------------------------------------
-- MongoDB ایجاد قسمت های مورد نیاز جهت اتصال به
Use AdventureWorks2016
GO

Create Master Key Encryption By Password = N'Rj983kWB@*74!'
GO

Create Database Scoped Credential CreMongoDB With Identity = 'PolybaseUser', Secret = 'Te*y47120%&FLk';
GO

Create External Data Source MongoDBDataSource 
With 
(
 Location = 'odbc://Localhost:27017',
 Connection_Options = 'DSN=PolybaseToMongoDB',
 Credential = CreMongoDB
);
GO
---------------------------------------------------------------------------------------------------------------------
-- External Table ایجاد
Create External Table ExternalPerson
(
  [_id] NVARCHAR(255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
  [PersonID] FLOAT(53), 
  [FirstName] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS, 
  [LastName] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS, 
  [JobTitle] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS, 
  [Country] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS, 
  [Biography] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS
)
With
(
 Location = 'TestDB.Persons',
 Data_Source = MongoDBDataSource
);
GO
-------------------------------------------------------------------------------------------------------------------------
/*
 External Table ایجاد
 جهت بررسی یک سناریو
*/
Use AdventureWorks2016
GO

Create External Table ExternalSales
(
 [_id] NVARCHAR(255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
 [ProductKey] INT, 
 [OrderDateKey] INT, 
 [DueDateKey] INT, 
 [ShipDateKey] INT, 
 [ResellerKey] INT, 
 [EmployeeKey] INT, 
 [PromotionKey] INT, 
 [CurrencyKey] INT, 
 [SalesTerritoryKey] INT, 
 [SalesOrderNumber] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [SalesOrderLineNumber] INT, 
 [RevisionNumber] INT, 
 [OrderQuantity] INT, 
 [UnitPrice] FLOAT(53), 
 [ExtendedAmount] FLOAT(53), 
 [UnitPriceDiscountPct] FLOAT(53), 
 [DiscountAmount] FLOAT(53), 
 [ProductStandardCost] FLOAT(53), 
 [TotalProductCost] FLOAT(53), 
 [SalesAmount] FLOAT(53), 
 [TaxAmt] FLOAT(53), 
 [Freight] FLOAT(53), 
 [CarrierTrackingNumber] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [CustomerPONumber] NVARCHAR(4000) COLLATE SQL_Latin1_General_CP1_CI_AS
)
With
(
 Location = 'TestDB.Sales',
 Data_Source = MongoDBDataSource
);
GO
-----------------------------------------------------------------------------------------------------------------------------
-- Statistics آیجاد
Create Statistics StatsDueDateKeySalesAmount On ExternalSales (DueDateKey, SalesAmount)
With Fullscan
GO
--------------------------------------------------------------------------------------------------------------
-- MongoDB ایجاد کوئری جهت واکشی اطلاعات از
Select Sum(SalesAmount) As TotalSalesAmount From ExternalSales
Where DueDateKey >= 20030101 And DueDateKey <= 20030331
Option (Force ExternalPushdown)
------------------------------------------------------------------------------------------------------------
-- نمایش مجموع فروش کالاها به ازای کارمندان در سه ماه انتهایی یک سال خاص 
Use AdventureWorks2016
GO

Select pe.FirstName + ' ' + pe.LastName As EmpName, pr.Name,
pe.BusinessEntityID, pr.ProductID,
SUM(es.SalesAmount) As TotalSalesAmount From ExternalSales es
Inner Join Person.Person pe
 On es.EmployeeKey = pe.BusinessEntityID
Inner Join Production.Product pr
 On pr.ProductID = es.ProductKey
Where es.DueDateKey >= 20031001 And es.DueDateKey <= 20031231
Group By pe.FirstName + ' ' + pe.LastName, 
BusinessEntityID, pr.Name, pr.ProductID
Option(Force ExternalPushdown)
