﻿--------------------------------------------------------------------
/*
 SQL Server در Polybase
Site:        http://www.NikAmooz.com
Email:       Info@NikAmooz.com
Instagram:   https://instagram.com/nikamooz/
Telegram:	 https://telegram.me/nikamooz
Created By:  Masoud Taheri , Mehdi Ghapanvari 
*/
--------------------------------------------------------------------
/*
 External Table ایجاد
 Primary در سرور
*/
Create External Table ExternalPerson
(
 [BusinessEntityID] INT NOT NULL, 
 [PersonType] NCHAR(2) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
 [NameStyle] BIT NOT NULL, 
 [Title] NVARCHAR(8) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [FirstName] NVARCHAR(50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
 [MiddleName] NVARCHAR(50) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [LastName] NVARCHAR(50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
 [Suffix] NVARCHAR(10) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [EmailPromotion] INT NOT NULL, 
 [AdditionalContactInfo] NVARCHAR(MAX) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [Demographics] NVARCHAR(MAX) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [rowguid] UNIQUEIDENTIFIER NOT NULL, 
 [ModifiedDate] DATETIME2(3) NOT NULL
)
With 
(
 Location = N'AdventureWorks.Person.Person',
 Data_Source = SQLServerDataSource
------------------------------------------------------------------------------------------------------

-- External Table اجرای کوئری بر روی 
Select * from ExternalPerson Where MiddleName = 'j'
------------------------------------------------------------------------

-- Statistics ایجاد
Create Statistics StatsMiddleName On ExternalPerson (MiddleName)
With Fullscan
------------------------------------------------------------------------

-- External Table اجرای کوئری دیگر بر روی
Select * from ExternalPerson Where LastName = 'Randall'
------------------------------------------------------------------------

-- Statistics ایجاد

Create Statistics LastNameStats On ExternalPerson (LastName)
With Fullscan
-----------------------------------------------------------------------

-- External Table ایجاد

Use SQLServerDB
GO

Drop External Table ExternalSalesInfo
GO

Create External Table ExternalSalesInfo
(
 [ProductKey] INT NOT NULL, 
 [OrderDateKey] INT NOT NULL, 
 [DueDateKey] INT NOT NULL, 
 [ShipDateKey] INT NOT NULL, 
 [ResellerKey] INT NOT NULL, 
 [EmployeeKey] INT NOT NULL, 
 [PromotionKey] INT NOT NULL, 
 [CurrencyKey] INT NOT NULL, 
 [SalesTerritoryKey] INT NOT NULL, 
 [SalesOrderNumber] NVARCHAR(20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
 [SalesOrderLineNumber] TINYINT NOT NULL, 
 [RevisionNumber] TINYINT, 
 [OrderQuantity] SMALLINT, 
 [UnitPrice] MONEY, [ExtendedAmount] MONEY, 
 [UnitPriceDiscountPct] FLOAT(53), 
 [DiscountAmount] FLOAT(53), 
 [ProductStandardCost] MONEY, 
 [TotalProductCost] MONEY, 
 [SalesAmount] MONEY, 
 [TaxAmt] MONEY, 
 [Freight] MONEY, 
 [CarrierTrackingNumber] NVARCHAR(25) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [CustomerPONumber] NVARCHAR(25) COLLATE SQL_Latin1_General_CP1_CI_AS
)
With 
(
 Location = N'DemoPageOrganization..SalesInfo',
 Data_Source = SQLServerDataSource
)
GO
------------------------------------------------------------------------------------------------------

-- External Table اجرای کوئری بر روی

Select Count(SalesOrderNumber) as TotalCount from ExternalSalesInfo 
Where DueDateKey Between 20030721 And 20030821 And CurrencyKey = 100
---------------------------------------------------------------------------------------------

-- اجرای کوئری به شکل دیگر
Drop Table If Exists #Tbl

Create Table #Tbl (CuKey Int)

Insert Into #Tbl Values (100)

Select Count(SalesOrderNumber) as TotalCOunt from ExternalSalesInfo esi
Inner Join #Tbl t
 on t.CuKey = esi.CurrencyKey
Where DueDateKey Between 20030721 And 20030821
GO
------------------------------------------------------------------------------------------
/* اعمال فیلتر و
 Aggregate
 External Table بر روی
*/
Drop Table If Exists #Tbl

Create Table #Tbl (ProductKey Int)

Insert Into #Tbl Values (360), (361), (362), (363), (364), (365), (366), (367), (368), (369), (370)

Create Statistics NewStats On ExternalSalesInfo
(SalesTerritoryKey, EmployeeKey, ProductKey, DueDateKey)
With Fullscan

Select SalesTerritoryKey, EmployeeKey, Count(*) as TotalCOunt from ExternalSalesInfo esi
Inner Join #Tbl t
 on t.ProductKey = esi.ProductKey
Where DueDateKey Between 20030101 And 20070101
Group by SalesTerritoryKey, EmployeeKey
Order by SalesTerritoryKey, EmployeeKey
Option (Force ExternalPushdown)
GO
-------------------------------------------------------------------------------------------------------------

/*
 NonClustered INDEX ایجاد
 در سمت سرور ریموت
*/
Create INDEX IXNCTEST ON SALESINFO (EmployeeKey, ProductKey)
INCLUDE (CURRENCYKEY)
WITH (DATA_COMPRESSION = PAGE)
--------------------------------------------------------------------------------------------------
-- Statistics ایجاد
Create Statistics MainStats On ExternalSalesInfo
(EmployeeKey, ProductKey, CurrencyKey)
With Fullscan
GO
---------------------------------------------------------------------------------------------
-- اجرای کوئری
Drop Table If Exists #EMPTbl

Create Table #EMPTbl
(EmployeeID Int, ProductID Int)

Insert Into #EMPTbl Values (281, 360), (285, 370)

Select CurrencyKey From ExternalSalesInfo esi
Inner Join #EMPTbl e
 On e.EmployeeID = esi.EmployeeKey And e.ProductID = esi.ProductKey
Option (Force ExternalPushdown)
-------------------------------------------------------------------------------
-- بررسی یک کوئری آنالیزی
Drop Table If Exists #EMPTbl

Create Table #EMPTbl
(EmployeeID Int, ProductID Int)

Insert Into #EMPTbl Values (281, 360), (285, 370)

Select CurrencyKey, Count(*) As TotalCount From ExternalSalesInfo esi
Inner Join #EMPTbl e
 On e.EmployeeID = esi.EmployeeKey And e.ProductID = esi.ProductKey
Group By CurrencyKey
Option (Force ExternalPushdown)
-------------------------------------------------------------------------------------
-- Pushdown فعال و غیر فعال نمودن
-- Statistics ایجاد
Create Statistics StatsSalesOrderNumber On ExternalSalesInfo (SalesOrderNumber)
With Fullscan
-------------------------------------------------------------------------------------

-- Pushdown غیر فعال نمودن
Select * From ExternalSalesInfo
Where SalesOrderNumber = N'SO50759-20040110-1'
Option (Disable ExternalPushdown)
------------------------------------------------------------------------------------

-- Pushdown فعال نمودن
Select * From ExternalSalesInfo
Where SalesOrderNumber = N'SO50759-20040110-1'
Option (Force ExternalPushdown)
------------------------------------------------------------------------------

-- ایجاد ویو در سمت سرور ریموت
Create View vwMain
As
Select * From SalesInfo
-------------------------------------------------------------------

-- External TABLE ایجاد 
-- جهت خواندن داده ها از ویو
Create External Table ExternalMainView
(
 [ProductKey] INT NOT NULL, 
 [OrderDateKey] INT NOT NULL, 
 [DueDateKey] INT NOT NULL, 
 [ShipDateKey] INT NOT NULL, 
 [ResellerKey] INT NOT NULL, 
 [EmployeeKey] INT NOT NULL, 
 [PromotionKey] INT NOT NULL, 
 [CurrencyKey] INT NOT NULL, 
 [SalesTerritoryKey] INT NOT NULL, 
 [SalesOrderNumber] NVARCHAR(20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
 [SalesOrderLineNumber] TINYINT NOT NULL, 
 [RevisionNumber] TINYINT, 
 [OrderQuantity] SMALLINT, 
 [UnitPrice] MONEY, [ExtendedAmount] MONEY, 
 [UnitPriceDiscountPct] FLOAT(53), 
 [DiscountAmount] FLOAT(53), 
 [ProductStandardCost] MONEY, 
 [TotalProductCost] MONEY, 
 [SalesAmount] MONEY, 
 [TaxAmt] MONEY, 
 [Freight] MONEY, 
 [CarrierTrackingNumber] NVARCHAR(25) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [CustomerPONumber] NVARCHAR(25) COLLATE SQL_Latin1_General_CP1_CI_AS
)
With 
(
 Location = N'DemoPageOrganization..vwMain',
 Data_Source = SQLServerDataSource)
 GO
------------------------------------------------------------------------------------------------------
