﻿--------------------------------------------------------------------
/*
 SQL Server در Polybase
Site:        http://www.NikAmooz.com
Email:       Info@NikAmooz.com
Instagram:   https://instagram.com/nikamooz/
Telegram:	 https://telegram.me/nikamooz
Created By:  Masoud Taheri , Mehdi Ghapanvari 
*/
--------------------------------------------------------------------
-- Polybase فعال نمودن ویژگی 

Exec sp_Configure N'polybase enabled', 1
Reconfigure with override
GO
-------------------------------------------------------------------------------------------------------
-- Polybase نمایش فعال بودن ویژگی
Select SERVERPROPERTY(N'IsPolybaseInstalled') As IsPolybaseInstalled, @@SERVERNAME As ServerName
GO
-------------------------------------------------------------------------------------------------------

-- Polybase Scale-Out GROUP نمایش نود های شرکت کننده در

Select * from sys.dm_exec_compute_nodes
---------------------------------------------------------------------------------------------------------
-- Polybase Scale-Out Group  انجام تنظیم
-- با استفاده از پروسیجر

Exec sp_Polybase_Join_Group 'PRIMARYSERVRE', 16450, 'MSSQLSERVER'
-----------------------------------------------------------------------------------------------------------

-- Polybase Scale-Out GROUP حذف یک نود از

Exec sp_Polybase_Leave_Group;
-----------------------------------------------------------------------

-- External Table ایجاد

Create Database Test
GO



Use Test
GO

Create Master Key Encryption By Password = N'Gl12es*!74'
GO

Create Database Scoped Credential ScaleOutCredential
With Identity = 'DemoLogin', Secret = 'Qy675*k745&!'
GO

Create External Data Source DemoDataSource
With 
(
 Location = 'sqlserver://192.168.1.1:1433',
 Credential = ScaleOutCredential
)
GO

Create External Table ExternalDemoTable
(
 [ProductKey] INT NOT NULL, 
 [OrderDateKey] INT NOT NULL, 
 [DueDateKey] INT NOT NULL, 
 [ShipDateKey] INT NOT NULL, 
 [ResellerKey] INT NOT NULL, 
 [EmployeeKey] INT NOT NULL, 
 [PromotionKey] INT NOT NULL, 
 [CurrencyKey] INT NOT NULL, 
 [SalesTerritoryKey] INT NOT NULL, 
 [SalesOrderNumber] NVARCHAR(20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL, 
 [SalesOrderLineNumber] TINYINT NOT NULL, 
 [RevisionNumber] TINYINT, 
 [OrderQuantity] SMALLINT, 
 [UnitPrice] MONEY, [ExtendedAmount] MONEY, 
 [UnitPriceDiscountPct] FLOAT(53), 
 [DiscountAmount] FLOAT(53), 
 [ProductStandardCost] MONEY, 
 [TotalProductCost] MONEY, 
 [SalesAmount] MONEY, [TaxAmt] MONEY, 
 [Freight] MONEY, 
 [CarrierTrackingNumber] NVARCHAR(25) COLLATE SQL_Latin1_General_CP1_CI_AS, 
 [CustomerPONumber] NVARCHAR(25) COLLATE SQL_Latin1_General_CP1_CI_AS
)
With
(
 Location = 'DemoPageOrganization..ColumnstoreTable',
 Data_Source = DemoDataSource
);

Create Statistics DemoStats On ExternalDemoTable (DueDateKey, ProductKey)
With Fullscan
GO
-------------------------------------------------------------------------------------------

-- بدست آوردن تعداد فروش هر محصول در بازه زمانی مشخص 
Select ProductKey, Count(*) As TotalCount from ExternalDemoTable
Where DueDateKey Between 20040101 And 20060901
Group By ProductKey
Order by ProductKey
option (force externalpushdown)
GO
-----------------------------------------------------------------------------

